# line 14 "Parallel.lh"
#ifndef Parallel_H
#define Parallel_H
# line 25 "Parallel.lh"
#define PAR_FIXED_HDR 			(GA_HDR_SIZE)
#define PAR_HDR_POSN			AFTER_INFO_HDR
#define AFTER_PAR_HDR			(PAR_HDR_POSN+PAR_FIXED_HDR)

#define SET_PAR_HDR(closure,ga)		
#define SET_STATIC_PAR_HDR(closure)	
# line 34 "Parallel.lh"
# ifdef PAR
#  define MAX_PES	256		
	





extern I_ do_sp_profile;

extern P_ PendingFetches;
extern GLOBAL_TASK_ID *PEs;

extern rtsBool IAmMainThread, GlobalStopPending;
extern rtsBool fishing;
extern GLOBAL_TASK_ID SysManTask;
extern int seed;			
					
extern I_ threadId;                     
extern GLOBAL_TASK_ID mytid;

extern int  nPEs;

extern rtsBool InGlobalGC;  	

extern HashTable *pGAtoGALAtable;
extern HashTable *LAtoGALAtable;
extern GALA *freeIndirections;
extern GALA *liveIndirections;
extern GALA *freeGALAList;
extern GALA *liveRemoteGAs;
extern int thisPE;

void RunParallelSystem PROTO((StgPtr program_closure));
void initParallelSystem(STG_NO_ARGS);
void SynchroniseSystem(STG_NO_ARGS);

void registerTask PROTO((GLOBAL_TASK_ID gtid));
globalAddr *LAGAlookup PROTO((P_ addr));
P_ GALAlookup PROTO((globalAddr *ga));
globalAddr *MakeGlobal PROTO((P_ addr, rtsBool preferred));
globalAddr *setRemoteGA PROTO((P_ addr, globalAddr *ga, rtsBool preferred));
void splitWeight PROTO((globalAddr *to, globalAddr *from));
globalAddr *addWeight PROTO((globalAddr *ga));
void initGAtables(STG_NO_ARGS);
W_ taskIDtoPE PROTO((GLOBAL_TASK_ID gtid));
void RebuildLAGAtable(STG_NO_ARGS);

void *lookupHashTable PROTO((HashTable *table, StgWord key));
void insertHashTable PROTO((HashTable *table, StgWord key, void *data));
void freeHashTable PROTO((HashTable *table, void (*freeDataFun) PROTO((void *data))));
HashTable *allocHashTable(STG_NO_ARGS);
void *removeHashTable PROTO((HashTable *table, StgWord key, void *data));

extern void myexit PROTO((I_));
#  define EXIT myexit
#  define exit : error : Wrong exit!
# else
#  define EXIT exit
# endif

# line 106 "Parallel.lh"
# if !(defined(GRAN) || defined(PAR))

#  define GA_HDR_SIZE			0
#  define	GA(closure)	        	
  
#  define SET_GA(closure,ga)		
#  define SET_STATIC_GA(closure)		
#  define SET_GRAN_HDR(closure,pe)        
#  define SET_STATIC_PROCS(closure)	
  
#  define SET_TASK_ACTIVITY(act)	    	

#endif

#if defined(GRAN)

#  define GA_HDR_SIZE			1

#  define PROCS_HDR_POSN		PAR_HDR_POSN
#  define PROCS_HDR_SIZE		1


#  define	PROCS(closure)	        (*((P_)(closure)+PROCS_HDR_POSN))

#  define SET_PROCS(closure, procs) \
	PROCS(closure) = (W_)(procs)   	
#  define SET_GRAN_HDR(closure,pe)	SET_PROCS(closure,pe)

#   define SET_STATIC_PROCS(closure)	, (W_) (Everywhere)

#  define SET_TASK_ACTIVITY(act)    	
#endif
# line 155 "Parallel.lh"
#if defined(PAR) 

#  define GA_HDR_SIZE			0
  
#  define GA(closure)		        getGA(closure)
  
#  define SET_GA(closure, ga)             setGA(closure,ga)
#  define SET_STATIC_GA(closure)
#  define SET_GRAN_HDR(closure,pe)
#  define SET_STATIC_PROCS(closure)
  
#  define MAX_GA_WEIGHT			0	
  
W_ PackGA PROTO((W_, int));
   



# line 178 "Parallel.lh"

#  define SET_TASK_ACTIVITY(act)

# line 231 "Parallel.lh"
#  define FETCHME_VHS				IND_VHS
#  define FETCHME_HS				IND_HS
  
#  define FETCHME_GA_LOCN                       FETCHME_HS
  
#  define FETCHME_CLOSURE_SIZE(closure)		IND_CLOSURE_SIZE(closure)
#  define FETCHME_CLOSURE_NoPTRS(closure)		0L
#  define FETCHME_CLOSURE_NoNONPTRS(closure)	(IND_CLOSURE_SIZE(closure)-IND_VHS)
  
#  define SET_FETCHME_HDR(closure,infolbl,cc,size,ptrs)	\
{ SET_FIXED_HDR(closure,FetchMe_info,<bogus CC>);	\
  SET_MUT_RESERVED_WORDS(closure);			\
}

#  define FETCHME_GA(closure)		(((globalAddr **)(closure))[FETCHME_GA_LOCN])

EXTFUN(FetchMe_entry);
EXTDATA_RO(FetchMe_info);

# line 276 "Parallel.lh"
#  define BF_VHS			    (GC_MUT_RESERVED_WORDS)
#  define BF_HS			    (FIXED_HS + BF_VHS)
  
#  define BF_LINK_LOCN		    (BF_HS)
#  define BF_NODE_LOCN		    (BF_HS + 1)
#  define BF_GTID_LOCN		    (BF_HS + 2)
#  define BF_SLOT_LOCN		    (BF_HS + 3)
#  define BF_WEIGHT_LOCN		    (BF_HS + 4)
  
#  define BF_CLOSURE_NoPTRS(closure)    2
#  define BF_CLOSURE_NoNONPTRS(closure) 3
  
#  define BF_CLOSURE_SIZE(closure)    (BF_VHS + 5)
  
#  define BF_LINK(closure)	    (((PP_)closure)[BF_LINK_LOCN])
#  define BF_NODE(closure)	    (((PP_)closure)[BF_NODE_LOCN])
#  define BF_GTID(closure)	    (((P_)closure)[BF_GTID_LOCN])
#  define BF_SLOT(closure)	    (((P_)closure)[BF_SLOT_LOCN])
#  define BF_WEIGHT(closure)	    (((P_)closure)[BF_WEIGHT_LOCN])
  
#  define BF_CLOSURE_PTR(closure, no) (((P_)(closure))[BF_HS + (no) - 1])


#  define SET_BF_HDR(closure,infolbl,cc)   	\
{ SET_FIXED_HDR(closure,infolbl,cc);		\
  SET_MUT_RESERVED_WORDS(closure); 	    	\
}

EXTFUN(BF_entry);
EXTDATA_RO(BF_info);

# line 321 "Parallel.lh"
#  define FMBQ_VHS			BQ_VHS
#  define FMBQ_HS			BQ_HS
  
#  define FMBQ_CLOSURE_SIZE(closure)	BQ_CLOSURE_SIZE(closure)
#  define FMBQ_CLOSURE_NoPTRS(closure)	BQ_CLOSURE_NoPTRS(closure)
#  define FMBQ_CLOSURE_NoNONPTRS(closure)	BQ_CLOSURE_NoNONPTRS(closure)
#  define FMBQ_CLOSURE_PTR(closure, no)	BQ_CLOSURE_PTR(closure, no)
  
#  define FMBQ_ENTRIES(closure)		BQ_ENTRIES(closure)
#  define FMBQ_LINK(closure)		BQ_LINK(closure)

EXTFUN(FMBQ_entry);
EXTDATA_RO(FMBQ_info);
# line 353 "Parallel.lh"

#  define FETCHME_ITBL(itbl_name,entry_code)			\
    CAT_DECLARE(FetchMe,INTERNAL_KIND,"FetchMe","<FetchMe>")	\
    EXTFUN(entry_code);						\
    EXTDATA_RO(MK_REP_LBL(FetchMe,,));				\
    const W_ itbl_name[] = {					\
        (W_) entry_code					    	\
	,(W_) INFO_OTHER_TAG					\
	,(W_) MK_REP_REF(FetchMe,,)				\
	INCLUDE_PROFILING_INFO(FetchMe)				\
    }

#  define FETCHME_RTBL() 					\
    const W_ MK_REP_LBL(FetchMe,,)[] = { 			\
	INCLUDE_TYPE_INFO(FETCHME)				\
	INCLUDE_SIZE_INFO(MIN_UPD_SIZE, 0L)			\
	INCLUDE_PAR_INFO				 	\
	INCLUDE_COPYING_INFO(_Evacuate_FetchMe,_Scavenge_FetchMe) \
	INCLUDE_COMPACTING_INFO(_ScanLink_FetchMe,_PRStart_FetchMe,_ScanMove_FetchMe,_PRIn_Error) \
    }

# line 385 "Parallel.lh"

#  define BF_ITBL()				    \
    CAT_DECLARE(BF,INTERNAL_KIND,"BlockedFetch","<BlockedFetch>")    \
    EXTFUN(BF_entry);			    \
    EXTDATA_RO(MK_REP_LBL(BF,,));		    \
    const W_ BF_info[] = {		    \
        (W_) BF_entry			    \
	,(W_) INFO_OTHER_TAG			    \
	,(W_) MK_REP_REF(BF,,)		    \
	INCLUDE_PROFILING_INFO(BF)	    \
	}

#  define BF_RTBL() \
    const W_ MK_REP_LBL(BF,,)[] = { \
	INCLUDE_TYPE_INFO(BF)				\
	INCLUDE_SIZE_INFO(BF_CLOSURE_SIZE(dummy),BF_CLOSURE_NoPTRS(dummy))	\
	INCLUDE_PAR_INFO					\
	INCLUDE_COPYING_INFO(_Evacuate_BF,_Scavenge_BF) 	\
	INCLUDE_COMPACTING_INFO(_ScanLink_BF,_PRStart_BF,_ScanMove_BF,_PRIn_BF) \
	}

# line 417 "Parallel.lh"
#  define FMBQ_ITBL()				\
    CAT_DECLARE(FMBQ,INTERNAL_KIND,"FMBQ","<FMBQ>") 	\
    EXTFUN(FMBQ_entry);				\
    EXTDATA_RO(MK_REP_LBL(FMBQ,,));		\
    const W_ FMBQ_info[] = {			\
        (W_) FMBQ_entry				\
	,(W_) INFO_OTHER_TAG			\
	,(W_) MK_REP_REF(FMBQ,,)		\
	INCLUDE_PROFILING_INFO(FMBQ)		\
    }

#  define FMBQ_RTBL() \
    const W_ MK_REP_LBL(FMBQ,,)[] = {				\
	INCLUDE_TYPE_INFO(FMBQ)		    			\
	INCLUDE_SIZE_INFO(MIN_UPD_SIZE,INFO_UNUSED)		\
	INCLUDE_PAR_INFO			    	    	\
	INCLUDE_COPYING_INFO(_Evacuate_BQ,_Scavenge_BQ)     	\
	SPEC_COMPACTING_INFO(_ScanLink_BQ,_PRStart_BQ,_ScanMove_BQ,_PRIn_BQ) \
    }

# line 446 "Parallel.lh"
#   define HAVE_SPARK ((PendingSparksHd[REQUIRED_POOL] < PendingSparksTl[REQUIRED_POOL]) \
		||  (PendingSparksHd[ADVISORY_POOL] < PendingSparksTl[ADVISORY_POOL]))

#  define HAVE_WORK  	(RUNNING_THREAD || HAVE_SPARK)
#  define RUNNING_THREAD  (CurrentTSO != NULL)
# line 466 "Parallel.lh"
void	InitPackBuffer(STG_NO_ARGS);
P_      PackTSO PROTO((P_ tso, W_ *size));
P_      PackStkO PROTO((P_ stko, W_ *size));
P_	AllocateHeap PROTO((W_ size)); 

void    InitClosureQueue (STG_NO_ARGS);
P_      DeQueueClosure(STG_NO_ARGS);
void    QueueClosure PROTO((P_ closure));
rtsBool QueueEmpty(STG_NO_ARGS);
void    PrintPacket PROTO((P_ buffer));

P_      get_closure_info PROTO((P_ closure, W_ *size, W_ *ptrs, W_ *nonptrs, W_ *vhs, char *type));

rtsBool isOffset PROTO((globalAddr *ga)),
	isFixed PROTO((globalAddr *ga));

void    doGlobalGC(STG_NO_ARGS);

P_      PackNearbyGraph PROTO((P_ closure,W_ *size));
P_      UnpackGraph PROTO((W_ *buffer, globalAddr **gamap, W_ *nGAs));
# line 489 "Parallel.lh"
#    define PACK_HEAP_REQUIRED  \
      ((RTSflags.ParFlags.packBufferSize - PACK_HDR_SIZE) / (PACK_GA_SIZE + _FHS) * (SPEC_HS + 2))

extern W_      *PackBuffer;      
extern long *buffer;             
extern W_ *freeBuffer;           
extern W_ *packBuffer;           

extern void    InitPackBuffer(STG_NO_ARGS);
extern void    InitMoreBuffers(STG_NO_ARGS);
extern void    InitPendingGABuffer(W_ size); 
extern void    AllocClosureQueue(W_ size);

#  define MAX_GAS 	(RTSflags.ParFlags.packBufferSize / PACK_GA_SIZE)


#  define PACK_GA_SIZE	3	
			        
#  define PACK_FETCHME_SIZE (PACK_GA_SIZE + FIXED_HS)

#  define PACK_HDR_SIZE	1	

#  define PACK_PLC_SIZE	2	

#endif
# line 516 "Parallel.lh"

#if defined(GRAN)

void  InitPackBuffer(STG_NO_ARGS);
P_    AllocateHeap PROTO((W_ size)); 
P_    PackNearbyGraph PROTO((P_ closure, P_ tso, W_ *packbuffersize));
P_    PackOneNode PROTO((P_ closure, P_ tso, W_ *packbuffersize));
P_    UnpackGraph PROTO((P_ buffer));

void    InitClosureQueue (STG_NO_ARGS);
P_      DeQueueClosure(STG_NO_ARGS);
void    QueueClosure PROTO((P_ closure));
rtsBool QueueEmpty(STG_NO_ARGS);
void    PrintPacket PROTO((P_ buffer));

P_      get_closure_info PROTO((P_ closure, W_ *size, W_ *ptrs, W_ *nonptrs, W_ *vhs, char *type));



#  define FETCHME_VHS				IND_VHS
#  define FETCHME_HS				IND_HS
  
#  define FETCHME_GA_LOCN                       FETCHME_HS
  
#  define FETCHME_CLOSURE_SIZE(closure)		IND_CLOSURE_SIZE(closure)
#  define FETCHME_CLOSURE_NoPTRS(closure)		0L
#  define FETCHME_CLOSURE_NoNONPTRS(closure)	(IND_CLOSURE_SIZE(closure)-IND_VHS)
  
#  define MAX_GAS 	(RTSflags.GranFlags.packBufferSize / PACK_GA_SIZE)
#  define PACK_GA_SIZE	3	
			        
#  define PACK_FETCHME_SIZE (PACK_GA_SIZE + FIXED_HS)
#  define PACK_HDR_SIZE	4	

#    define PACK_HEAP_REQUIRED  \
      ((RTSflags.GranFlags.packBufferSize - PACK_HDR_SIZE) / (PACK_GA_SIZE \
      + _FHS) * (SPEC_HS + 2)) 

#    define PACK_FLAG_LOCN           0  
#    define PACK_TSO_LOCN            1
#    define PACK_UNPACKED_SIZE_LOCN  2
#    define PACK_SIZE_LOCN           3
#    define MAGIC_PACK_FLAG          0xfabc
#endif  

#endif 
