# line 7 "StgMacros.lh"
#ifndef STGMACROS_H
#define STGMACROS_H
# line 19 "StgMacros.lh"

#define STGFUN(f)  F_ f(STG_NO_ARGS)
#define STATICFUN(f) static F_ f(STG_NO_ARGS)


#define EXTFUN(f)	extern F_ f(STG_NO_ARGS)
#define EXTDATA(d)	extern W_ d[]
#define EXTDATA_RO(d)	extern const W_ d[] 



#define INTFUN(f)	static F_ f(STG_NO_ARGS)
#define INTDATA(d)	extern W_ d[]
#define INTDATA_RO(d)	extern const W_ d[] 



#define FN_(f)		F_ f(STG_NO_ARGS)
#define IFN_(f)		static F_ f(STG_NO_ARGS)
#define EF_(f)		extern F_ f(STG_NO_ARGS)
#define ED_(d)		extern W_ d[]
#define ED_RO_(d)	extern const W_ d[] 
#define IF_(f)		static F_ f(STG_NO_ARGS)



#if defined(__GNUC__)
#define ID_(d)		extern W_ d[]
#define ID_RO_(d)	extern const W_ d[] 
#else
#define ID_(d)		static W_ d[]
#define ID_RO_(d)	static const W_ d[] 
#endif 
# line 57 "StgMacros.lh"
I_ STG_MAX PROTO((I_, I_)); 

extern STG_INLINE
I_
STG_MAX(I_ a, I_ b) { return((a >= b) ? a : b); }












#define	COMBINE_WORDS(word,short1,short2)		\
	do {						\
	    ((packed_shorts *)&(word))->wu.s1 = short1;	\
	    ((packed_shorts *)&(word))->wu.s2 = short2;	\
	} while(0)

#define SPLIT_WORD(word,short1,short2)			\
	do {						\
	    short1 = ((packed_shorts *)&(word))->wu.s1;	\
	    short2 = ((packed_shorts *)&(word))->wu.s2;	\
	} while(0)

# line 101 "StgMacros.lh"
#ifdef __STG_REV_TBLS__
#define UNVECTBL(staticp,label,a)   
#else
#define UNVECTBL(staticp,label,a) \
EXTFUN(a); \
staticp const W_ label[] = { \
  (W_) a \
};
#endif
# line 113 "StgMacros.lh"
#if defined(USE_SPLIT_MARKERS)
#define __STG_SPLIT_MARKER(n) FN_(CAT2(__stg_split_marker,n)){ }
#else
#define __STG_SPLIT_MARKER(n) 
#endif
# line 133 "StgMacros.lh"
#define SUBTRACT_A_STK( upper, lower ) AREL( (lower) - (upper) )
#define SUBTRACT_B_STK( upper, lower ) BREL( (lower) - (upper) )
# line 152 "StgMacros.lh"
#define ARGS_CHK_A(n)						\
	if (SuA  < (SpA+(n))) {	\
		JMP_( UpdatePAP );				\
	}

#define ARGS_CHK_A_LOAD_NODE(n, closure_addr)			\
	if (SuA  < (SpA+(n))) {	\
		Node = (P_) closure_addr;			\
		JMP_( UpdatePAP );				\
	}

#define ARGS_CHK_B(n)						\
	if (SpB  < (SuB-(n))) {	\
		JMP_( UpdatePAP );				\
	}


#define ARGS_CHK_B_LOAD_NODE(n, closure_addr)			\
	if (SpB  < (SuB-(n))) {	\
		Node = (P_) closure_addr;			\
		JMP_( UpdatePAP );				\
	}
# line 190 "StgMacros.lh"
extern I_ SqueezeUpdateFrames PROTO((P_, P_, P_));
int sanityChk_StkO (P_ stko); 

#if ! defined(CONCURRENT)

extern void StackOverflow(STG_NO_ARGS) STG_NORETURN;

#if STACK_CHECK_BY_PAGE_FAULT

#define STACK_OVERFLOW(liveness,hda,hdb,spa,spb,rtype,reenter)	\
    

#else

#define STACK_OVERFLOW(liveness,hda,hdb,spa,spb,rtype,reenter)	\
    ULTRASAFESTGCALL0(void,(void *),StackOverflow)

#endif 

#else 

extern I_ StackOverflow PROTO((W_, W_));






#define STACK_OVERFLOW(liveness,hda,hdb,spa,spb,rtype,reenter) \
    DO_STACKOVERFLOW((hda+hdb)<<2|((rtype)<<1)|(reenter),((spa)<<20)|((spb)<<8)|(liveness))

#define STACK_OVERFLOW_HEADROOM(args,y)	    ((args) >> 2)
#define STACK_OVERFLOW_PRIM_RETURN(args,y)  ((args) & 2)
#define STACK_OVERFLOW_REENTER(args,y)	    ((args) & 1)

#define STACK_OVERFLOW_AWORDS(x,args)	    (((args) >> 20) & 0x0fff)
#define STACK_OVERFLOW_BWORDS(x,args)	    (((args) >> 8) & 0x0fff)
#define STACK_OVERFLOW_LIVENESS(x,args)	    ((args) & 0xff)

#endif	

#define STK_CHK(liveness_mask,a_headroom,b_headroom,spa,spb,ret_type,reenter)\
do {								\
  DO_ASTK_HWM(); 			\
  DO_BSTK_HWM();						\
  if (STKS_OVERFLOW_OP((a_headroom) + 1, (b_headroom) + 1)) {	\
    STACK_OVERFLOW(liveness_mask,a_headroom,b_headroom,spa,spb,ret_type,reenter);\
  }								\
}while(0)
# line 252 "StgMacros.lh"
#if defined(__DO_ARITY_CHKS__)

extern I_			 ExpectedArity;
extern void ArityError PROTO((I_)) STG_NORETURN;

#define SET_ARITY(n) do { ExpectedArity = (n); } while(0)
#define CHK_ARITY(n)			\
	do {				\
	if (ExpectedArity != (n)) {	\
	    ULTRASAFESTGCALL1(void,(void *, I_),ArityError,n);	\
	}}while(0)

#else 

#define SET_ARITY(n) 
#define CHK_ARITY(n) 

#endif 
# line 282 "StgMacros.lh"
extern void PerformGC PROTO((W_));
void RealPerformGC PROTO((W_ liveness, W_ reqsize, W_  always_reenter_node, rtsBool do_full_collection));
void checkInCCallGC(STG_NO_ARGS);

#ifndef PAR
void StgPerformGarbageCollection(STG_NO_ARGS);
#endif

#ifndef CONCURRENT

#define OR_MSG_PENDING	

#define HEAP_OVERFLOW(liveness,n,reenter)	\
    do {					\
    DO_GC((((W_)n)<<8)|(liveness));		\
    } while (0)

#define REQSIZE_BITMASK	((1L << ((BITS_IN(W_) - 8 + 1))) - 1)
#define HEAP_OVERFLOW_REQSIZE(args)	(((args) >> 8) & REQSIZE_BITMASK)
#define HEAP_OVERFLOW_REENTER(args)	0
#define HEAP_OVERFLOW_LIVENESS(args)	((args) & 0xff)

#else 

extern void ReallyPerformThreadGC PROTO((W_, rtsBool));

#define HEAP_OVERFLOW(liveness,n,reenter) 	\
    do {					\
    DO_GC((((W_)(n))<<9)|((reenter)<<8)|(liveness)); \
    } while (0)

#define REQSIZE_BITMASK	((1L << ((BITS_IN(W_) - 9 + 1))) - 1)
#define HEAP_OVERFLOW_REQSIZE(args)	(((args) >> 9) & REQSIZE_BITMASK)
#define HEAP_OVERFLOW_REENTER(args)	(((args) >> 8) & 0x1)
#define HEAP_OVERFLOW_LIVENESS(args)	((args) & 0xff)

#ifndef PAR

#define OR_MSG_PENDING	

#else 

extern int PacketsWaiting;		
extern int heapChkCounter;		
					

#define OR_MSG_PENDING	

#endif	
#endif	

#if 0 
#define CACHE_LINE  4	
#define LINES_AHEAD 3
#define PRE_FETCH(n)					\
do {							\
 StgInt j;						\
 j = ((STG_VOLATILE StgInt *) Hp)[LINES_AHEAD * CACHE_LINE];	\
} while(0);
#define EXTRA_HEAP_WORDS (CACHE_LINE * LINES_AHEAD)
#else
#define PRE_FETCH(reg)
#define EXTRA_HEAP_WORDS 0
#endif

#if defined(GRAN)
#define HEAP_CHK(liveness_mask,n,reenter)			\
	do {							\
			\
		        \
	ALLOC_HEAP(n); 			\
        GRAN_ALLOC_HEAP(n,liveness_mask);  \
	if (((Hp = Hp + (n)) > HpLim)) {			\
	    \
	    HEAP_OVERFLOW(liveness_mask,n,StgFalse); \
	}}while(0)

#else

#define HEAP_CHK(liveness_mask,n,reenter)		\
do {							\
  		\
  PRE_FETCH(n);						\
  ALLOC_HEAP(n); 			\
  if (((Hp = Hp + (n)) > HpLim) OR_INTERVAL_EXPIRED OR_CONTEXT_SWITCH OR_MSG_PENDING) {	\
    HEAP_OVERFLOW(liveness_mask,n,reenter);		\
  }							\
} while(0)

#endif  

#ifdef CONCURRENT

#define HEAP_CHK_AND_RESTORE_N(liveness_mask,n,reenter)	\
do {							\
  		\
  PRE_FETCH(n);						\
  ALLOC_HEAP(n); 			\
  if (((Hp = Hp + (n)) > HpLim) OR_INTERVAL_EXPIRED OR_CONTEXT_SWITCH OR_MSG_PENDING) {	\
    HEAP_OVERFLOW(liveness_mask,n,reenter);		\
    n = TSO_ARG1(CurrentTSO);				\
  }} while(0)

#else

#define HEAP_CHK_AND_RESTORE_N(liveness_mask,n,reenter)	    \
    HEAP_CHK(liveness_mask,n,reenter)

#endif

# line 417 "StgMacros.lh"
#define gtCharZh(r,a,b)	r=(I_)((a)> (b))
#define geCharZh(r,a,b)	r=(I_)((a)>=(b))
#define eqCharZh(r,a,b)	r=(I_)((a)==(b))
#define neCharZh(r,a,b)	r=(I_)((a)!=(b))
#define ltCharZh(r,a,b)	r=(I_)((a)< (b))
#define leCharZh(r,a,b)	r=(I_)((a)<=(b))

#define gtIntZh(r,a,b)	r=(I_)((a) >(b))
#define geIntZh(r,a,b)	r=(I_)((a)>=(b))
#define eqIntZh(r,a,b)	r=(I_)((a)==(b))
#define neIntZh(r,a,b)	r=(I_)((a)!=(b))
#define ltIntZh(r,a,b)	r=(I_)((a) <(b))
#define leIntZh(r,a,b)	r=(I_)((a)<=(b))

#define gtWordZh(r,a,b)	r=(I_)((a) >(b))
#define geWordZh(r,a,b)	r=(I_)((a)>=(b))
#define eqWordZh(r,a,b)	r=(I_)((a)==(b))
#define neWordZh(r,a,b)	r=(I_)((a)!=(b))
#define ltWordZh(r,a,b)	r=(I_)((a) <(b))
#define leWordZh(r,a,b)	r=(I_)((a)<=(b))

#define gtAddrZh(r,a,b)	r=(I_)((a) >(b))
#define geAddrZh(r,a,b)	r=(I_)((a)>=(b))
#define eqAddrZh(r,a,b)	r=(I_)((a)==(b))
#define neAddrZh(r,a,b)	r=(I_)((a)!=(b))
#define ltAddrZh(r,a,b)	r=(I_)((a) <(b))
#define leAddrZh(r,a,b)	r=(I_)((a)<=(b))

#define gtFloatZh(r,a,b)  r=(I_)((a)> (b))
#define geFloatZh(r,a,b)  r=(I_)((a)>=(b))
#define eqFloatZh(r,a,b)  r=(I_)((a)==(b))
#define neFloatZh(r,a,b)  r=(I_)((a)!=(b))
#define ltFloatZh(r,a,b)  r=(I_)((a)< (b))
#define leFloatZh(r,a,b)  r=(I_)((a)<=(b))

#define gtDoubleZh(r,a,b) r=(I_)((a)> (b))
#define geDoubleZh(r,a,b) r=(I_)((a)>=(b))
#define eqDoubleZh(r,a,b) r=(I_)((a)==(b))
#define neDoubleZh(r,a,b) r=(I_)((a)!=(b))
#define ltDoubleZh(r,a,b) r=(I_)((a)< (b))
#define leDoubleZh(r,a,b) r=(I_)((a)<=(b))
# line 469 "StgMacros.lh"
#define ordZh(r,a)	r=(I_)((W_) (a))
#define chrZh(r,a)	r=(StgChar)((W_)(a))
# line 480 "StgMacros.lh"
I_ stg_div PROTO((I_ a, I_ b));

#define plusIntZh(r,a,b)	r=(a)+(b)
#define minusIntZh(r,a,b)	r=(a)-(b)
#define timesIntZh(r,a,b)	r=(a)*(b)
#define quotIntZh(r,a,b)	r=(a)/(b)
#define divIntZh(r,a,b)		r=ULTRASAFESTGCALL2(I_,(void *, I_, I_),stg_div,(a),(b))
#define remIntZh(r,a,b)		r=(a)%(b)
#define negateIntZh(r,a)	r=-(a)
# line 498 "StgMacros.lh"
#define andZh(r,a,b)	r=(a)&(b)
#define orZh(r,a,b)	r=(a)|(b)
#define notZh(r,a)	r=~(a)

#define shiftLZh(r,a,b)	  r=(a)<<(b)
#define shiftRAZh(r,a,b)  r=(a)>>(b)
#define shiftRLZh(r,a,b)  r=(a)>>(b)
#define iShiftLZh(r,a,b)  r=(a)<<(b)
#define iShiftRAZh(r,a,b) r=(a)>>(b)
#define iShiftRLZh(r,a,b) r=(a)>>(b)

#define int2WordZh(r,a) r=(W_)(a)
#define word2IntZh(r,a) r=(I_)(a)
# line 520 "StgMacros.lh"
#define int2AddrZh(r,a) r=(A_)(a)
#define addr2IntZh(r,a) r=(I_)(a)
# line 531 "StgMacros.lh"
#define plusFloatZh(r,a,b)	r=(a)+(b)
#define minusFloatZh(r,a,b)	r=(a)-(b)
#define timesFloatZh(r,a,b)	r=(a)*(b)
#define divideFloatZh(r,a,b)	r=(a)/(b)
#define negateFloatZh(r,a)	r=-(a)

#define int2FloatZh(r,a)	r=(StgFloat)(a)
#define float2IntZh(r,a)	r=(I_)(a)

#define expFloatZh(r,a)		r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),exp,a)
#define logFloatZh(r,a)		r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),log,a)
#define sqrtFloatZh(r,a)	r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),sqrt,a)
#define sinFloatZh(r,a)		r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),sin,a)
#define cosFloatZh(r,a)		r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),cos,a)
#define tanFloatZh(r,a)		r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),tan,a)
#define asinFloatZh(r,a)	r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),asin,a)
#define acosFloatZh(r,a)	r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),acos,a)
#define atanFloatZh(r,a)	r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),atan,a)
#define sinhFloatZh(r,a)	r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),sinh,a)
#define coshFloatZh(r,a)	r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),cosh,a)
#define tanhFloatZh(r,a)	r=(StgFloat) SAFESTGCALL1(StgDouble,(void *, StgDouble),tanh,a)
#define powerFloatZh(r,a,b)	r=(StgFloat) SAFESTGCALL2(StgDouble,(void *, StgDouble,StgDouble),pow,a,b)


# line 564 "StgMacros.lh"
#define plusDoubleZh(r,a,b)	r=(a)+(b)
#define minusDoubleZh(r,a,b)	r=(a)-(b)
#define timesDoubleZh(r,a,b)	r=(a)*(b)
#define divideDoubleZh(r,a,b)	r=(a)/(b)
#define negateDoubleZh(r,a)	r=-(a)

#define int2DoubleZh(r,a)	r=(StgDouble)(a)
#define double2IntZh(r,a)	r=(I_)(a)

#define float2DoubleZh(r,a)	r=(StgDouble)(a)
#define double2FloatZh(r,a)	r=(StgFloat)(a)

#define expDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),exp,a)
#define logDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),log,a)
#define sqrtDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),sqrt,a)
#define sinDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),sin,a)
#define cosDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),cos,a)
#define tanDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),tan,a)
#define asinDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),asin,a)
#define acosDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),acos,a)
#define atanDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),atan,a)
#define sinhDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),sinh,a)
#define coshDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),cosh,a)
#define tanhDoubleZh(r,a)	r=(StgDouble) SAFESTGCALL1(StgDouble,(void *, StgDouble),tanh,a)
#define powerDoubleZh(r,a,b)	r=(StgDouble) SAFESTGCALL2(StgDouble,(void *, StgDouble,StgDouble),pow,a,b)
# line 606 "StgMacros.lh"
#define gmpTake1Return1(size_chk_macro, liveness, mpz_op, ar,sr,dr, aa,sa,da)	\
{ MP_INT arg;									\
  MP_INT result;								\
  I_ space = size_chk_macro(sa);						\
										\
  	\
  GMP_HEAP_LOOKAHEAD(liveness,space);						\
										\
  				\
  arg.alloc	= (aa);								\
  arg.size	= (sa);								\
  arg.d		= (unsigned long int *) (BYTE_ARR_CTS(da));			\
										\
  SAFESTGCALL1(void,(void *, MP_INT *),mpz_init,&result);			\
										\
  							\
  SAFESTGCALL2(void,(void *, MP_INT *, MP_INT *),mpz_op,&result,&arg);		\
										\
  GMP_HEAP_HANDBACK();						\
  (ar) = result.alloc;								\
  (sr) = result.size;								\
  (dr) = (B_) (result.d - DATA_HS);						\
   \
}


#define gmpTake2Return1(size_chk_macro, liveness, mpz_op, ar,sr,dr, a1,s1,d1, a2,s2,d2)\
{ MP_INT arg1;									\
  MP_INT arg2;									\
  MP_INT result;								\
  I_ space = size_chk_macro(s1,s2);						\
										\
  	\
  GMP_HEAP_LOOKAHEAD(liveness,space);						\
										\
  				\
  arg1.alloc	= (a1);								\
  arg1.size	= (s1);								\
  arg1.d	= (unsigned long int *) (BYTE_ARR_CTS(d1));			\
  arg2.alloc	= (a2);								\
  arg2.size	= (s2);								\
  arg2.d	= (unsigned long int *) (BYTE_ARR_CTS(d2));			\
										\
  SAFESTGCALL1(void,(void *, MP_INT *),mpz_init,&result);			\
										\
  							\
  SAFESTGCALL3(void,(void *, MP_INT *, MP_INT *, MP_INT *),mpz_op,&result,&arg1,&arg2); \
										\
  GMP_HEAP_HANDBACK();						\
  (ar) = result.alloc;								\
  (sr) = result.size;								\
  (dr) = (B_) (result.d - DATA_HS);						\
   \
}

#define gmpTake2Return2(size_chk_macro, liveness, mpz_op, ar1,sr1,dr1, ar2,sr2,dr2, a1,s1,d1, a2,s2,d2) \
{ MP_INT arg1;									\
  MP_INT arg2;									\
  MP_INT result1;								\
  MP_INT result2;								\
  I_ space = size_chk_macro(s1,s2);						\
										\
  	\
  GMP_HEAP_LOOKAHEAD(liveness,space);						\
										\
  				\
  arg1.alloc	= (a1);								\
  arg1.size	= (s1);								\
  arg1.d	= (unsigned long int *) (BYTE_ARR_CTS(d1));			\
  arg2.alloc	= (a2);								\
  arg2.size	= (s2);								\
  arg2.d	= (unsigned long int *) (BYTE_ARR_CTS(d2));			\
										\
  SAFESTGCALL1(void,(void *, MP_INT *),mpz_init,&result1);			\
  SAFESTGCALL1(void,(void *, MP_INT *),mpz_init,&result2);			\
										\
  							\
  SAFESTGCALL4(void,(void *, MP_INT *, MP_INT *, MP_INT *, MP_INT *),mpz_op,&result1,&result2,&arg1,&arg2); \
										\
  GMP_HEAP_HANDBACK();						\
  (ar1) = result1.alloc;							\
  (sr1) = result1.size;								\
  (dr1) = (B_) (result1.d - DATA_HS);						\
  (ar2) = result2.alloc;							\
  (sr2) = result2.size;								\
  (dr2) = (B_) (result2.d - DATA_HS);						\
}
# line 700 "StgMacros.lh"
#define __abs(a)		(( (a) >= 0 ) ? (a) : (-(a)))
#define GMP_SIZE_ONE()		(2 + DATA_HS + 16)
#define GMP_SAME_SIZE(a)	(__abs(a) + DATA_HS + 16)
#define GMP_MAX_SIZE(a,b)	((__abs(a) > __abs(b) ? __abs(a) : __abs(b)) + 1 + DATA_HS + 16)
				
#define GMP_2MAX_SIZE(a,b)	(2 * GMP_MAX_SIZE(a,b))
#define GMP_ADD_SIZES(a,b)	(__abs(a) + __abs(b) + 1 + DATA_HS + 16)
				
# line 729 "StgMacros.lh"
#define GMP_HEAP_LOOKAHEAD(liveness,n)			\
	do {						\
	HEAP_CHK_AND_RESTORE_N(liveness,n,0);		\
	Hp = Hp - (n);					\
	UN_ALLOC_HEAP(n);		\
	SAVE_Hp = Hp;			\
	DEBUG_SetGMPAllocBudget(n)			\
	}while(0)

#define GMP_HEAP_HANDBACK()				\
	Hp = SAVE_Hp;					\
	DEBUG_ResetGMPAllocBudget()
# line 744 "StgMacros.lh"
void *stgAllocForGMP   PROTO((size_t size_in_bytes));
void *stgReallocForGMP PROTO((void *ptr, size_t old_size, size_t new_size));
void stgDeallocForGMP  PROTO((void *ptr, size_t size));

#ifdef ALLOC_DEBUG
extern StgInt DEBUG_GMPAllocBudget;
#define DEBUG_SetGMPAllocBudget(n)  DEBUG_GMPAllocBudget = (n);
#define DEBUG_ResetGMPAllocBudget() DEBUG_GMPAllocBudget = 0;
#else
#define DEBUG_SetGMPAllocBudget(n)  
#define DEBUG_ResetGMPAllocBudget() 
#endif
# line 760 "StgMacros.lh"
#define negateIntegerZh(ar,sr,dr, liveness, aa,sa,da) \
	gmpTake1Return1(GMP_SAME_SIZE, liveness, mpz_neg, ar,sr,dr, aa,sa,da)

#define plusIntegerZh(ar,sr,dr, liveness, a1,s1,d1, a2,s2,d2) \
	gmpTake2Return1(GMP_MAX_SIZE, liveness, mpz_add, ar,sr,dr, a1,s1,d1, a2,s2,d2)
#define minusIntegerZh(ar,sr,dr, liveness, a1,s1,d1, a2,s2,d2) \
	gmpTake2Return1(GMP_MAX_SIZE, liveness, mpz_sub, ar,sr,dr, a1,s1,d1, a2,s2,d2)
#define timesIntegerZh(ar,sr,dr, liveness, a1,s1,d1, a2,s2,d2) \
	gmpTake2Return1(GMP_ADD_SIZES, liveness, mpz_mul, ar,sr,dr, a1,s1,d1, a2,s2,d2)



#define quotRemIntegerZh(ar1,sr1,dr1, ar2,sr2,dr2, liveness, a1,s1,d1, a2,s2,d2) \
	gmpTake2Return2(GMP_2MAX_SIZE, liveness, mpz_divmod, ar1,sr1,dr1, ar2,sr2,dr2, a1,s1,d1, a2,s2,d2)
#define divModIntegerZh(ar1,sr1,dr1, ar2,sr2,dr2, liveness,  a1,s1,d1, a2,s2,d2) \
	gmpTake2Return2(GMP_2MAX_SIZE, liveness, mpz_mdivmod, ar1,sr1,dr1, ar2,sr2,dr2, a1,s1,d1, a2,s2,d2)
# line 781 "StgMacros.lh"
#define cmpIntegerZh(r, hp, a1,s1,d1, a2,s2,d2) 		\
{ MP_INT arg1;									\
  MP_INT arg2;									\
  						\
										\
  arg1.alloc	= (a1);								\
  arg1.size	= (s1);								\
  arg1.d	= (unsigned long int *) (BYTE_ARR_CTS(d1));			\
  arg2.alloc	= (a2);								\
  arg2.size	= (s2);								\
  arg2.d	= (unsigned long int *) (BYTE_ARR_CTS(d2));			\
										\
  (r) = SAFESTGCALL2(I_,(void *, MP_INT *, MP_INT *),mpz_cmp,&arg1,&arg2);	\
}
# line 800 "StgMacros.lh"
#define integer2IntZh(r, hp, aa,sa,da)						\
{ MP_INT arg;									\
  						\
										\
  arg.alloc	= (aa);								\
  arg.size	= (sa);								\
  arg.d		= (unsigned long int *) (BYTE_ARR_CTS(da));			\
										\
  (r) = SAFESTGCALL1(I_,(void *, MP_INT *),mpz_get_si,&arg);			\
}






#define int2IntegerZh(ar,sr,dr, hp, i)						\
{ StgInt val; 				\
										\
  val = (i);  							\
										\
  SET_DATA_HDR((hp),ArrayOfData_info,CCC,DATA_VHS+MIN_MP_INT_SIZE,0);		\
										\
  if	  ((val) < 0) { (sr) = -1; (hp)[DATA_HS] = -(val); }			\
  else if ((val) > 0) { (sr) =	1; (hp)[DATA_HS] =  (val); }			\
  else    { (sr) =	0; }						\
  (ar) = 1;									\
  (dr) = (B_)(hp);					\
}

#define word2IntegerZh(ar,sr,dr, hp, i)						\
{ StgWord val; 				\
										\
  val = (i);  							\
										\
  SET_DATA_HDR((hp),ArrayOfData_info,CCC,DATA_VHS+MIN_MP_INT_SIZE,0);		\
										\
  if ((val) != 0)     { (sr) =	1; (hp)[DATA_HS] =  (val); }			\
  else    { (sr) =	0; }						\
  (ar) = 1;									\
  (dr) = (B_)(hp);					\
}

# line 847 "StgMacros.lh"










#define addr2IntegerZh(ar,sr,dr, liveness, str)					\
{ MP_INT result;								\
  							\
  I_ space = GMP_SAME_SIZE(sizeof(str) / 8 + 1);				\
										\
  GMP_HEAP_LOOKAHEAD(liveness, space);						\
										\
  							\
  if (SAFESTGCALL3(I_,(void *, MP_INT *, char *, int), mpz_init_set_str,&result,(str),10)) \
      abort();									\
										\
  GMP_HEAP_HANDBACK();						\
  (ar) = result.alloc;								\
  (sr) = result.size;								\
  (dr) = (B_) (result.d - DATA_HS);						\
   \
}
# line 880 "StgMacros.lh"
StgFloat  __encodeFloat	 PROTO((MP_INT *, I_));
void  __decodeFloat  PROTO((MP_INT * ,
				I_ * ,
				StgFloat));

StgDouble __encodeDouble PROTO((MP_INT *, I_));
void  __decodeDouble PROTO((MP_INT * ,
				I_ * ,
				StgDouble));
# line 894 "StgMacros.lh"


#if sparc_TARGET_ARCH	\
 || alpha_TARGET_ARCH	\
 || hppa1_1_TARGET_ARCH	\
 || i386_TARGET_ARCH	\
 || m68k_TARGET_ARCH	\
 || mipsel_TARGET_ARCH	\
 || mipseb_TARGET_ARCH	\
 || powerpc_TARGET_ARCH


#include "ieee-flpt.h"

#if alpha_dec_osf1_TARGET	\
 || i386_TARGET_ARCH		\
 || mipsel_TARGET_ARCH

#undef BIGENDIAN 
#else
#define BIGENDIAN 1
#endif

#else 

******* ERROR *********** Any ideas about floating-point format?

#endif 
# line 925 "StgMacros.lh"
#if alpha_dec_osf1_TARGET
#define encodeFloatZh(r, hp, aa,sa,da, expon)	encodeDoubleZh(r, hp, aa,sa,da, expon)
#else
#define encodeFloatZh(r, hp, aa,sa,da, expon)	\
{ MP_INT arg;					\
  		\
						\
  arg.alloc	= aa;				\
  arg.size	= sa;				\
  arg.d		= (unsigned long int *) (BYTE_ARR_CTS(da)); \
						\
  r = SAFESTGCALL2(StgFloat,(void *, MP_INT *, I_), __encodeFloat,&arg,(expon));	\
}
#endif 

#define encodeDoubleZh(r, hp, aa,sa,da, expon)	\
{ MP_INT arg;					\
  		\
						\
  arg.alloc	= aa;				\
  arg.size	= sa;				\
  arg.d		= (unsigned long int *) (BYTE_ARR_CTS(da)); \
						\
  r = SAFESTGCALL2(StgDouble,(void *, MP_INT *, I_), __encodeDouble,&arg,(expon));\
}

#if alpha_dec_osf1_TARGET
#define decodeFloatZh(exponr, ar,sr,dr, hp, f)	decodeDoubleZh(exponr, ar,sr,dr, hp, f)
#else
#define decodeFloatZh(exponr, ar,sr,dr, hp, f)				\
{ MP_INT mantissa;							\
  I_ exponent;								\
  StgFloat arg = (f);							\
									\
  		\
  	\
  SET_DATA_HDR(hp,ArrayOfData_info,CCC,DATA_VHS+MIN_MP_INT_SIZE,0);	\
  mantissa.d = (hp) + DATA_HS;						\
									\
  						\
  SAFESTGCALL3(void,(void *, MP_INT *, I_ *, StgFloat),__decodeFloat,&mantissa,&exponent,arg);		\
  exponr= exponent;							\
  ar	= mantissa.alloc;						\
  sr	= mantissa.size;						\
  dr	= (B_)(hp);							\
}
#endif 

#define decodeDoubleZh(exponr, ar,sr,dr, hp, f)				\
{ MP_INT mantissa;							\
  I_ exponent;								\
  StgDouble arg = (f);							\
									\
  		\
  	\
  SET_DATA_HDR(hp,ArrayOfData_info,CCC,DATA_VHS+MIN_MP_INT_SIZE,0);	\
  mantissa.d = (hp) + DATA_HS;						\
									\
  						\
  SAFESTGCALL3(void,(void *, MP_INT *, I_ *, StgDouble),__decodeDouble,&mantissa,&exponent,arg);		\
  exponr= exponent;							\
  ar	= mantissa.alloc;						\
  sr	= mantissa.size;						\
  dr	= (B_)(hp);							\
}
# line 1005 "StgMacros.lh"
#if alpha_TARGET_ARCH	\
 || i386_TARGET_ARCH	\
 || m68k_TARGET_ARCH

#define ASSIGN_FLT(dst, src) *(StgFloat *)(dst) = (src);
#define PK_FLT(src) (*(StgFloat *)(src))

#define ASSIGN_DBL(dst, src) *(StgDouble *)(dst) = (src);
#define PK_DBL(src) (*(StgDouble *)(src))

#else	



#define FLOAT_ALIGNMENT_TROUBLES    TRUE

#if ! defined(__GNUC__) || ! defined(__STG_GCC_REGS__)

void	    ASSIGN_DBL PROTO((W_ [], StgDouble));
StgDouble   PK_DBL     PROTO((W_ []));
void	    ASSIGN_FLT PROTO((W_ [], StgFloat));
StgFloat    PK_FLT     PROTO((W_ []));

#else 

#if sparc_TARGET_ARCH

#define ASSIGN_FLT(dst, src) *(StgFloat *)(dst) = (src);
#define PK_FLT(src) (*(StgFloat *)(src))

#define ASSIGN_DBL(dst,src) \
      __asm__("st %2,%0\n\tst %R2,%1" : "=m" (((P_)(dst))[0]), \
	"=m" (((P_)(dst))[1]) : "f" (src));

#define PK_DBL(src) \
    ( { register double d; \
      __asm__("ld %1,%0\n\tld %2,%R0" : "=f" (d) : \
	"m" (((P_)(src))[0]), "m" (((P_)(src))[1])); d; \
    } )

#else 


void	    ASSIGN_DBL PROTO((W_ [], StgDouble));
StgDouble   PK_DBL     PROTO((W_ []));
void	    ASSIGN_FLT PROTO((W_ [], StgFloat));
StgFloat    PK_FLT     PROTO((W_ []));

extern STG_INLINE
void
ASSIGN_DBL(W_ p_dest[], StgDouble src)
{
    double_thing y;
    y.d = src;
    p_dest[0] = y.du.dhi;
    p_dest[1] = y.du.dlo;
}






extern STG_INLINE
StgDouble
PK_DBL(W_ p_src[])
{
    double_thing y;
    y.du.dhi = p_src[0];
    y.du.dlo = p_src[1];
    return(y.d);
}

extern STG_INLINE
void
ASSIGN_FLT(W_ p_dest[], StgFloat src)
{
    float_thing y;
    y.f = src;
    *p_dest = y.fu;
}

extern STG_INLINE
StgFloat
PK_FLT(W_ p_src[])
{
    float_thing y;
    y.fu = *p_src;
    return(y.f);
}

#endif 

#endif 

#endif 
# line 1120 "StgMacros.lh"

#ifdef DEBUG
#define BYTE_ARR_CTS(a)					\
 ({ ASSERT(INFO_PTR(a) == (W_) ArrayOfData_info);	\
    ((C_ *) (((StgPtr) (a))+DATA_HS)); })
#define PTRS_ARR_CTS(a)					\
 ({ ASSERT((INFO_PTR(a) == (W_) ArrayOfPtrs_info)	\
	|| (INFO_PTR(a) == (W_) ImMutArrayOfPtrs_info));\
    ((a)+MUTUPLE_HS);} )
#else
#define BYTE_ARR_CTS(a)		((char *) (((StgPtr) (a))+DATA_HS))
#define PTRS_ARR_CTS(a)		((a)+MUTUPLE_HS)
#endif


extern I_ genSymZh(STG_NO_ARGS);
extern I_ resetGenSymZh(STG_NO_ARGS);
extern I_ incSeqWorldZh(STG_NO_ARGS);


extern I_ long2bytes__	 PROTO((long,	unsigned char *));
extern I_ int2bytes__	 PROTO((int,	unsigned char *));
extern I_ short2bytes__	 PROTO((short,	unsigned char *));
extern I_ float2bytes__	 PROTO((float,	unsigned char *));
extern I_ double2bytes__ PROTO((double, unsigned char *));


extern I_ bytes2long__	 PROTO((P_, I_ *));
extern I_ bytes2int__	 PROTO((P_, I_ *));
extern I_ bytes2short__	 PROTO((P_, I_ *));
extern I_ bytes2float__	 PROTO((P_, StgFloat *));
extern I_ bytes2double__ PROTO((P_, StgDouble *));

extern I_ byteArrayHasNUL__ PROTO((const char *, I_));
# line 1175 "StgMacros.lh"
#define sameMutableArrayZh(r,a,b)	r=(I_)((a)==(b))
#define sameMutableByteArrayZh(r,a,b)	r=(I_)((B_)(a)==(B_)(b))

#define readArrayZh(r,a,i)	 r=((PP_) PTRS_ARR_CTS(a))[(i)]

#define readCharArrayZh(r,a,i)	 indexCharOffAddrZh(r,BYTE_ARR_CTS(a),i)
#define readIntArrayZh(r,a,i)	 indexIntOffAddrZh(r,BYTE_ARR_CTS(a),i)
#define readAddrArrayZh(r,a,i)	 indexAddrOffAddrZh(r,BYTE_ARR_CTS(a),i)
#define readFloatArrayZh(r,a,i)	 indexFloatOffAddrZh(r,BYTE_ARR_CTS(a),i)
#define readDoubleArrayZh(r,a,i) indexDoubleOffAddrZh(r,BYTE_ARR_CTS(a),i)


#define writeArrayZh(a,i,v)	((PP_) PTRS_ARR_CTS(a))[(i)]=(v)

#define writeCharArrayZh(a,i,v)	  ((C_ *)(BYTE_ARR_CTS(a)))[i] = (v)
#define writeIntArrayZh(a,i,v)	  ((I_ *)(BYTE_ARR_CTS(a)))[i] = (v)
#define writeAddrArrayZh(a,i,v)	  ((PP_)(BYTE_ARR_CTS(a)))[i] = (v)
#define writeFloatArrayZh(a,i,v)  \
	ASSIGN_FLT((P_) (((StgFloat *)(BYTE_ARR_CTS(a))) + i),v)
#define writeDoubleArrayZh(a,i,v) \
	ASSIGN_DBL((P_) (((StgDouble *)(BYTE_ARR_CTS(a))) + i),v)

#define indexArrayZh(r,a,i)	  r=((PP_) PTRS_ARR_CTS(a))[(i)]

#define indexCharArrayZh(r,a,i)	  indexCharOffAddrZh(r,BYTE_ARR_CTS(a),i)
#define indexIntArrayZh(r,a,i)	  indexIntOffAddrZh(r,BYTE_ARR_CTS(a),i)
#define indexAddrArrayZh(r,a,i)	  indexAddrOffAddrZh(r,BYTE_ARR_CTS(a),i)
#define indexFloatArrayZh(r,a,i)  indexFloatOffAddrZh(r,BYTE_ARR_CTS(a),i)
#define indexDoubleArrayZh(r,a,i) indexDoubleOffAddrZh(r,BYTE_ARR_CTS(a),i)

#define indexCharOffAddrZh(r,a,i)   r= ((C_ *)(a))[i]
#define indexIntOffAddrZh(r,a,i)    r= ((I_ *)(a))[i]
#define indexAddrOffAddrZh(r,a,i)   r= ((PP_)(a))[i]
#define indexFloatOffAddrZh(r,a,i)  r= PK_FLT((P_) (((StgFloat *)(a)) + i))
#define indexDoubleOffAddrZh(r,a,i) r= PK_DBL((P_) (((StgDouble *)(a)) + i))





#define unsafeFreezeArrayZh(r,a)				\
	do {						\
	P_ result;					\
	result=(P_) (a);				\
	FREEZE_MUT_HDR(result,ImMutArrayOfPtrs_info);	\
	r = result;					\
	}while(0)

#define unsafeFreezeByteArrayZh(r,a)	r=(B_)(a)
# line 1229 "StgMacros.lh"

















# line 1251 "StgMacros.lh"
#define newCharArrayZh(r,liveness,n)	newByteArray(r,liveness,(n) * sizeof(C_))
#define newIntArrayZh(r,liveness,n)	newByteArray(r,liveness,(n) * sizeof(I_))
#define newAddrArrayZh(r,liveness,n)	newByteArray(r,liveness,(n) * sizeof(P_))
#define newFloatArrayZh(r,liveness,n)	newByteArray(r,liveness,(n) * sizeof(StgFloat))
#define newDoubleArrayZh(r,liveness,n)	newByteArray(r,liveness,(n) * sizeof(StgDouble))

#define newByteArray(r,liveness,n)				\
{								\
  P_ result;							\
  I_ size;							\
								\
  HEAP_CHK(liveness,DATA_HS+BYTES_TO_STGWORDS(n),0);		\
  size = BYTES_TO_STGWORDS(n);					\
  ALLOC_PRIM(DATA_HS,size,0,DATA_HS+size) ;	\
  CC_ALLOC(CCC,DATA_HS+size,ARR_K);				\
								\
  result = Hp-(DATA_HS+size)+1;					\
  SET_DATA_HDR(result,ArrayOfData_info,CCC,DATA_VHS+size,0);	\
  r = (B_) result;						\
}
# line 1279 "StgMacros.lh"

void newArrZh_init PROTO((P_ result, I_ n, P_ init));

#define newArrayZh(r,liveness,n,init)			\
{							\
  P_ p;							\
  P_ result;						\
							\
  HEAP_CHK(liveness, MUTUPLE_HS+(n),0);			\
  ALLOC_PRIM(MUTUPLE_HS,(n),0,MUTUPLE_HS+(n)) ; \
  CC_ALLOC(CCC,MUTUPLE_HS+(n),ARR_K); 	\
							\
  result = Hp + 1 - (MUTUPLE_HS+(n));			\
  SET_MUTUPLE_HDR(result,ArrayOfPtrs_info,CCC,MUTUPLE_VHS+(n),0) \
  for (p = result+MUTUPLE_HS; p < (result+MUTUPLE_HS+(n)); p++) { \
	*p = (W_) (init);				\
  }							\
							\
  r = result;						\
}
# line 1308 "StgMacros.lh"
ED_(Nil_closure);

#define newSynchVarZh(r, hp) 				\
{							\
  ALLOC_PRIM(MUTUPLE_HS,3,0,MUTUPLE_HS+3) ; \
  CC_ALLOC(CCC,MUTUPLE_HS+3,ARR_K); 	\
  SET_SVAR_HDR(hp,EmptySVar_info,CCC);			\
  SVAR_HEAD(hp) = SVAR_TAIL(hp) = SVAR_VALUE(hp) = Nil_closure;	\
  r = hp;						\
}
# line 1321 "StgMacros.lh"
#ifdef CONCURRENT

extern void Yield PROTO((W_));

#define takeMVarZh(r, liveness, node)    		\
{							\
  while (INFO_PTR(node) != (W_) FullSVar_info) {	\
    if (SVAR_HEAD(node) == Nil_closure) 	    	\
      SVAR_HEAD(node) = CurrentTSO; 	    	    	\
    else    	    	    	    	    	    	\
      TSO_LINK(SVAR_TAIL(node)) = CurrentTSO;	    	\
    TSO_LINK(CurrentTSO) = (P_) Nil_closure;	    	\
    SVAR_TAIL(node) = CurrentTSO;   	    	    	\
    DO_YIELD(liveness << 1);				\
  } 	    	    	    	    	    	    	\
  SET_INFO_PTR(node, EmptySVar_info);			\
  r = SVAR_VALUE(node);	    	    	    	    	\
  SVAR_VALUE(node) = Nil_closure;   	    	    	\
}

#else

#define takeMVarZh(r, liveness, node)			\
{							\
  if (INFO_PTR(node) != (W_) FullSVar_info) {		\
    \
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "takeMVar#: MVar is empty.\n");    	\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  } 	    	    	    	    	    	    	\
  SET_INFO_PTR(node, EmptySVar_info);			\
  r = SVAR_VALUE(node);	    	    	    	    	\
  SVAR_VALUE(node) = Nil_closure;   	    	    	\
}

#endif
# line 1360 "StgMacros.lh"
#ifdef CONCURRENT

#ifdef GRAN






#define putMVarZh(node, value)	    			\
{							\
  P_ tso;   	    	    	    	    	    	\
  if (INFO_PTR(node) == (W_) FullSVar_info) {		\
    \
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "putMVar#: MVar already full.\n");	\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  } 	    	    	    	    	    	    	\
  SET_INFO_PTR(node, FullSVar_info);			\
  SVAR_VALUE(node) = value; 	    	    	    	\
  tso = SVAR_HEAD(node);    	    	    	    	\
  if (tso != (P_) Nil_closure) {    	    	    	\
    if (DO_QP_PROF) 	    	    	    	    	\
      STGCALL3(void,(void *, char *, P_, P_),QP_Event2,do_qp_prof > 1 ? "RA" : "RG",tso,CurrentTSO);	\
    if (ThreadQueueHd == Nil_closure)   	    	\
      ThreadQueueHd = tso;    	    	    	\
    else    	    	    	    	    	    	\
      TSO_LINK(ThreadQueueTl) = tso;  	    	\
    ThreadQueueTl = tso;	    	    	    	\
    SVAR_HEAD(node) = TSO_LINK(tso);  	    	    	\
    TSO_LINK(tso) = (P_) Nil_closure; 	    	    	\
    if(SVAR_HEAD(node) == (P_) Nil_closure)   	    	\
      SVAR_TAIL(node) = (P_) Nil_closure;	    	\
  } 	    	    	    	    	    	    	\
}

#else 

#define putMVarZh(node, value)	    			\
{							\
  P_ tso;   	    	    	    	    	    	\
  if (INFO_PTR(node) == (W_) FullSVar_info) {		\
    \
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "putMVar#: MVar already full.\n");	\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  } 	    	    	    	    	    	    	\
  SET_INFO_PTR(node, FullSVar_info);			\
  SVAR_VALUE(node) = value; 	    	    	    	\
  tso = SVAR_HEAD(node);    	    	    	    	\
  if (tso != (P_) Nil_closure) {    	    	    	\
    if (DO_QP_PROF) 	    	    	    	    	\
      STGCALL3(void,(void *, char *, P_, P_),QP_Event2,do_qp_prof > 1 ? "RA" : "RG",tso,CurrentTSO);	\
    if (RunnableThreadsHd == Nil_closure)   	    	\
      RunnableThreadsHd = tso;    	    	    	\
    else    	    	    	    	    	    	\
      TSO_LINK(RunnableThreadsTl) = tso;  	    	\
    RunnableThreadsTl = tso;	    	    	    	\
    SVAR_HEAD(node) = TSO_LINK(tso);  	    	    	\
    TSO_LINK(tso) = (P_) Nil_closure; 	    	    	\
    if(SVAR_HEAD(node) == (P_) Nil_closure)   	    	\
      SVAR_TAIL(node) = (P_) Nil_closure;	    	\
  } 	    	    	    	    	    	    	\
}

#endif  

#else

#define putMVarZh(node, value)    			\
{							\
  P_ tso;   	    	    	    	    	    	\
  if (INFO_PTR(node) == (W_) FullSVar_info) {		\
    \
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "putMVar#: MVar already full.\n");	\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  } 	    	    	    	    	    	    	\
  SET_INFO_PTR(node, FullSVar_info);			\
  SVAR_VALUE(node) = value; 	    	    	    	\
}

#endif
# line 1446 "StgMacros.lh"
#ifdef CONCURRENT

#define readIVarZh(r, liveness, node)			\
{							\
  if (INFO_PTR(node) != (W_) ImMutArrayOfPtrs_info) {	\
    if (SVAR_HEAD(node) == Nil_closure) 	    	\
      SVAR_HEAD(node) = CurrentTSO; 	    	    	\
    else    	    	    	    	    	    	\
      TSO_LINK(SVAR_TAIL(node)) = CurrentTSO;	    	\
    TSO_LINK(CurrentTSO) = (P_) Nil_closure;	    	\
    SVAR_TAIL(node) = CurrentTSO;   	    	    	\
    DO_YIELD(liveness << 1);				\
  } 	    	    	    	    	    	    	\
  r = SVAR_VALUE(node);	    	    	    	    	\
}

#else

#define readIVarZh(r, liveness, node)			\
{							\
  if (INFO_PTR(node) != (W_) ImMutArrayOfPtrs_info) {	\
    \
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "readIVar#: IVar is empty.\n");    	\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  } 	    	    	    	    	    	    	\
  r = SVAR_VALUE(node);	    	    	    	    	\
}

#endif
# line 1479 "StgMacros.lh"
#ifdef CONCURRENT

#ifdef GRAN






#define writeIVarZh(node, value)    			\
{							\
  P_ tso;   	    	    	    	    	    	\
  if (INFO_PTR(node) == (W_) ImMutArrayOfPtrs_info) {	\
    \
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "writeIVar#: IVar already full.\n");\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  } 	    	    	    	    	    	    	\
  tso = SVAR_HEAD(node);    	    	    	    	\
  if (tso != (P_) Nil_closure) {    	    	    	\
    if (ThreadQueueHd == Nil_closure)   	    	\
      ThreadQueueHd = tso;    	    	    	\
    else    	    	    	    	    	    	\
      TSO_LINK(ThreadQueueTl) = tso;  	    	\
    while(TSO_LINK(tso) != Nil_closure) {   	    	\
      if (DO_QP_PROF)	    	    	    	    	\
        STGCALL3(void,(void *, char *, P_, P_),QP_Event2,do_qp_prof > 1 ? "RA" : "RG",tso,CurrentTSO);	\
      tso = TSO_LINK(tso);  	    	    	    	\
    }	    	    	    	    	    	    	\
    if (DO_QP_PROF) 	    	    	    	    	\
      STGCALL3(void,(void *, char *, P_, P_),QP_Event2,do_qp_prof > 1 ? "RA" : "RG",tso,CurrentTSO);	\
    ThreadQueueTl = tso;	    	    	    	\
  } 	    	    	    	    	    	    	\
  	\
  SET_INFO_PTR(node, ImMutArrayOfPtrs_info);		\
  MUTUPLE_CLOSURE_SIZE(node) = (MUTUPLE_VHS+1);    	\
  SVAR_VALUE(node) = value; 	    	    	    	\
}

#else 

#define writeIVarZh(node, value)    			\
{							\
  P_ tso;   	    	    	    	    	    	\
  if (INFO_PTR(node) == (W_) ImMutArrayOfPtrs_info) {	\
    \
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "writeIVar#: IVar already full.\n");\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  } 	    	    	    	    	    	    	\
  tso = SVAR_HEAD(node);    	    	    	    	\
  if (tso != (P_) Nil_closure) {    	    	    	\
    if (RunnableThreadsHd == Nil_closure)   	    	\
      RunnableThreadsHd = tso;    	    	    	\
    else    	    	    	    	    	    	\
      TSO_LINK(RunnableThreadsTl) = tso;  	    	\
    while(TSO_LINK(tso) != Nil_closure) {   	    	\
      if (DO_QP_PROF)	    	    	    	    	\
        STGCALL3(void,(void *, char *, P_, P_),QP_Event2,do_qp_prof > 1 ? "RA" : "RG",tso,CurrentTSO);	\
      tso = TSO_LINK(tso);  	    	    	    	\
    }	    	    	    	    	    	    	\
    if (DO_QP_PROF) 	    	    	    	    	\
      STGCALL3(void,(void *, char *, P_, P_),QP_Event2,do_qp_prof > 1 ? "RA" : "RG",tso,CurrentTSO);	\
    RunnableThreadsTl = tso;	    	    	    	\
  } 	    	    	    	    	    	    	\
  	\
  SET_INFO_PTR(node, ImMutArrayOfPtrs_info);		\
  MUTUPLE_CLOSURE_SIZE(node) = (MUTUPLE_VHS+1);    	\
  SVAR_VALUE(node) = value; 	    	    	    	\
}

#endif  

#else

#define writeIVarZh(node, value)    			\
{							\
  P_ tso;   	    	    	    	    	    	\
  if (INFO_PTR(node) == (W_) ImMutArrayOfPtrs_info) {	\
    \
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "writeIVar#: IVar already full.\n");\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  } 	    	    	    	    	    	    	\
  	\
  SET_INFO_PTR(node, ImMutArrayOfPtrs_info);		\
  MUTUPLE_CLOSURE_SIZE(node) = (MUTUPLE_VHS+1);    	\
  SVAR_VALUE(node) = value; 	    	    	    	\
}

#endif
# line 1579 "StgMacros.lh"
#ifdef CONCURRENT



#define delayZh(liveness, us)				\
  {							\
    if (WaitingThreadsTl == Nil_closure)		\
      WaitingThreadsHd = CurrentTSO;			\
    else						\
      TSO_LINK(WaitingThreadsTl) = CurrentTSO;		\
    WaitingThreadsTl = CurrentTSO;			\
    TSO_LINK(CurrentTSO) = Nil_closure;			\
    TSO_EVENT(CurrentTSO) = (W_) ((us) < 1 ? 1 : (us)); \
    DO_YIELD(liveness << 1);				\
  }

#else

#define delayZh(liveness, us)				\
  {							\
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "delay#: unthreaded build.\n");    	\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  }

#endif

#ifdef CONCURRENT



#define waitReadZh(liveness, fd)			\
  {							\
    if (WaitingThreadsTl == Nil_closure)		\
      WaitingThreadsHd = CurrentTSO;			\
    else						\
      TSO_LINK(WaitingThreadsTl) = CurrentTSO;		\
    WaitingThreadsTl = CurrentTSO;			\
    TSO_LINK(CurrentTSO) = Nil_closure;			\
    TSO_EVENT(CurrentTSO) = (W_) (-(fd));		\
    DO_YIELD(liveness << 1);				\
  }

#else

#define waitReadZh(liveness, fd)			\
  {							\
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "waitRead#: unthreaded build.\n"); 	\
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  }

#endif

#ifdef CONCURRENT



#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif  HAVE_SYS_TYPES_H */

#define waitWriteZh(liveness, fd)			\
  {							\
    if (WaitingThreadsTl == Nil_closure)		\
      WaitingThreadsHd = CurrentTSO;			\
    else						\
      TSO_LINK(WaitingThreadsTl) = CurrentTSO;		\
    WaitingThreadsTl = CurrentTSO;			\
    TSO_LINK(CurrentTSO) = Nil_closure;			\
    TSO_EVENT(CurrentTSO) = (W_) (-(fd+FD_SETSIZE));	\
    DO_YIELD(liveness << 1);				\
  }

#else

#define waitWriteZh(liveness, fd)			\
  {							\
    fflush(stdout); 	    	    	    	    	\
    fprintf(stderr, "waitWrite#: unthreaded build.\n"); \
    EXIT(EXIT_FAILURE);	    	    	    	    	\
  }

#endif

# line 1673 "StgMacros.lh"
extern P_ TopClosure;
EXTFUN(ErrorIO_innards);
EXTFUN(__std_entry_error__);

#define errorIOZh(a)		\
    do { TopClosure=(a);	\
	 (void) SAFESTGCALL1(I_,(void *, FILE *),fflush,stdout); \
	 (void) SAFESTGCALL1(I_,(void *, FILE *),fflush,stderr); \
	 JMP_(ErrorIO_innards); \
    } while(0)

#if !defined(CALLER_SAVES_SYSTEM)

#define stg_getc(stream)	getc((FILE *) (stream))
#define stg_putc(c,stream)	putc((c),((FILE *) (stream)))
#else

#define stg_getc(stream)	SAFESTGCALL1(I_,(void *, FILE *),fgetc,(FILE *) (stream))
#define stg_putc(c,stream)	SAFESTGCALL2(I_,(void *, char, FILE *),fputc,(c),((FILE *) (stream)))
#endif

int initialize_virtual_timer(int us);
int install_segv_handler(STG_NO_ARGS);
int install_vtalrm_handler(STG_NO_ARGS);
void initUserSignals(STG_NO_ARGS);
void blockUserSignals(STG_NO_ARGS);
void unblockUserSignals(STG_NO_ARGS);
IF_RTS(void blockVtAlrmSignal(STG_NO_ARGS);)
IF_RTS(void unblockVtAlrmSignal(STG_NO_ARGS);)
IF_RTS(void AwaitEvent(I_ delta);)

#ifdef _POSIX_SOURCE
extern I_ sig_install PROTO((I_, I_, sigset_t *));
#define stg_sig_ignore(s,m)	SAFESTGCALL3(I_,(void *, I_, I_),sig_install,s,STG_SIG_IGN,(sigset_t *)m)
#define stg_sig_default(s,m)	SAFESTGCALL3(I_,(void *, I_, I_),sig_install,s,STG_SIG_DFL,(sigset_t *)m)
#define stg_sig_catch(s,sp,m)	SAFESTGCALL3(I_,(void *, I_, I_),sig_install,s,sp,(sigset_t *)m)
#else
extern I_ sig_install PROTO((I_, I_));
#define stg_sig_ignore(s,m)	SAFESTGCALL2(I_,(void *, I_, I_),sig_install,s,STG_SIG_IGN)
#define stg_sig_default(s,m)	SAFESTGCALL2(I_,(void *, I_, I_),sig_install,s,STG_SIG_DFL)
#define stg_sig_catch(s,sp,m)	SAFESTGCALL2(I_,(void *, I_, I_),sig_install,s,sp)
#endif

#define STG_SIG_DFL	(-1)
#define STG_SIG_IGN	(-2)
#define STG_SIG_ERR	(-3)

StgInt getErrorHandler(STG_NO_ARGS);
#ifndef PAR
void raiseError PROTO((StgStablePtr handler));
StgInt catchError PROTO((StgStablePtr newErrorHandler));
#endif
void decrementErrorCount(STG_NO_ARGS);

#define stg_catchError(sp)      SAFESTGCALL1(I_,(void *, StgStablePtr),catchError,sp)
#define stg_decrementErrorCount() SAFESTGCALL0(void,(void *),decrementErrorCount)
# line 1752 "StgMacros.lh"
#ifdef PAR

#define deRefStablePtrZh(ri,sp)					    \
do {								    \
    fflush(stdout);						    \
    fprintf(stderr, "deRefStablePtr#: no stable pointer support.\n");\
    EXIT(EXIT_FAILURE);						    \
} while(0)

#else 

extern StgPtr _deRefStablePointer PROTO((StgInt, StgPtr));

#define deRefStablePtrZh(ri,sp) \
   ri = SAFESTGCALL2(I_,(void *, I_, P_),_deRefStablePointer,sp,StorageMgrInfo.StablePointerTable);

# line 1773 "StgMacros.lh"
void	freeStablePointer	PROTO((I_ stablePtr));

void	enterStablePtr		PROTO((StgStablePtr, StgFunPtr));
void	performIO		PROTO((StgStablePtr));
I_	enterInt		PROTO((StgStablePtr));
I_	enterFloat		PROTO((StgStablePtr));
P_	deRefStablePointer	PROTO((StgStablePtr));
IF_RTS(I_ catchSoftHeapOverflow	PROTO((StgStablePtr, I_));)
IF_RTS(I_ getSoftHeapOverflowHandler(STG_NO_ARGS);)
IF_RTS(extern StgStablePtr softHeapOverflowHandler;)
IF_RTS(void shutdownHaskell(STG_NO_ARGS);)

EXTFUN(stopPerformIODirectReturn);
EXTFUN(startPerformIO);
EXTFUN(stopEnterIntDirectReturn);
EXTFUN(startEnterInt);
EXTFUN(stopEnterFloatDirectReturn);
EXTFUN(startEnterFloat);

void enterStablePtr PROTO((StgStablePtr stableIndex, StgFunPtr startCode));

#endif 

IF_RTS(extern I_ ErrorIO_call_count;)
# line 1815 "StgMacros.lh"
#ifndef PAR


#define SPTSizeFromNoPtrs( newNP ) (DYN_VHS + 1 + 2 * (newNP))



#define CalcNewNoSPtrs( i ) ((i)*2 + 100)

extern void enlargeSPTable PROTO((P_, P_));

#define makeStablePtrZh(stablePtr,liveness,unstablePtr)		    \
do {								    \
  EXTDATA_RO(StablePointerTable_info);				    \
  EXTDATA(UnusedSP);						    \
  StgStablePtr newSP;						    \
								    \
  if (SPT_EMPTY(StorageMgrInfo.StablePointerTable)) {  \
    { 		    \
      I_ OldNoPtrs = SPT_NoPTRS( StorageMgrInfo.StablePointerTable ); \
      I_ NewNoPtrs = CalcNewNoSPtrs( OldNoPtrs );		    \
      I_ NewSize = SPTSizeFromNoPtrs( NewNoPtrs );		    \
      HEAP_CHK(liveness, _FHS+NewSize, 0);			    \
    }								    \
    { 	    \
      I_ OldNoPtrs = SPT_NoPTRS( StorageMgrInfo.StablePointerTable ); \
      I_ NewNoPtrs = CalcNewNoSPtrs( OldNoPtrs );		    \
      I_ NewSize = SPTSizeFromNoPtrs( NewNoPtrs );		    \
      P_ SPTable = Hp + 1 - (_FHS + NewSize);			    \
								    \
      CC_ALLOC(CCC, _FHS+NewSize, SPT_K); 		    \
      SET_DYN_HDR(SPTable,StablePointerTable_info,CCC,NewSize,NewNoPtrs);\
      SAFESTGCALL2(void, (void *, P_, P_), enlargeSPTable, SPTable, StorageMgrInfo.StablePointerTable);	     \
      StorageMgrInfo.StablePointerTable = SPTable;		    \
    }								    \
  }								    \
								    \
  newSP = SPT_POP(StorageMgrInfo.StablePointerTable);		    \
  SPT_SPTR(StorageMgrInfo.StablePointerTable, newSP) = unstablePtr; \
  CHECK_SPT_CLOSURE( StorageMgrInfo.StablePointerTable );           \
  stablePtr = newSP;						    \
} while (0)

#else

#define makeStablePtrZh(stablePtr,liveness,unstablePtr)		    \
do {								    \
    fflush(stdout);						    \
    fprintf(stderr, "makeStablePtr#: no stable pointer support.\n");\
    EXIT(EXIT_FAILURE);						    \
} while(0)

#endif 
# line 1894 "StgMacros.lh"
#define reallyUnsafePtrEqualityZh(r,a,b) r=((StgPtr)(a) == (StgPtr)(b))
# line 1911 "StgMacros.lh"
#ifdef CONCURRENT

ED_(Nil_closure);
ED_(True_closure);

#if defined(GRAN)
#define parZh(r,node)				\
	PARZh(r,node,1,0,0,0,0,0)

#define parAtZh(r,node,where,identifier,gran_info,size_info,par_info,rest) \
	parATZh(r,node,where,identifier,gran_info,size_info,par_info,rest,1)

#define parAtAbsZh(r,node,proc,identifier,gran_info,size_info,par_info,rest) \
	parATZh(r,node,proc,identifier,gran_info,size_info,par_info,rest,2)

#define parAtRelZh(r,node,proc,identifier,gran_info,size_info,par_info,rest) \
	parATZh(r,node,proc,identifier,gran_info,size_info,par_info,rest,3)

#define parAtForNowZh(r,node,where,identifier,gran_info,size_info,par_info,rest)	\
	parATZh(r,node,where,identifier,gran_info,size_info,par_info,rest,0)

#define parATZh(r,node,where,identifier,gran_info,size_info,par_info,rest,local)	\
{							\
  sparkq result;						\
  if (SHOULD_SPARK(node)) {				\
    SaveAllStgRegs();		   	                \
    { sparkq result;						\
      result = NewSpark((P_)node,identifier,gran_info,size_info,par_info,local);	\
      if (local==2) {            \
        GranSimSparkAtAbs(result,(I_)where,identifier);\
      } else if (local==3) {     \
        GranSimSparkAtAbs(result,(I_)(CurrentProc+where),identifier);	\
      } else {       \
        GranSimSparkAt(result,where,identifier);	\
      }        \
      context_switch = 1;                        	\
    }                                                   \
    RestoreAllStgRegs();			        \
  } else if (do_qp_prof) {				\
    I_ tid = threadId++;				\
    SAFESTGCALL2(void,(I_, P_),QP_Event0,tid,node);	\
  }							\
  r = 1; 	\
}

#define parLocalZh(r,node,identifier,gran_info,size_info,par_info,rest)	\
	PARZh(r,node,rest,identifier,gran_info,size_info,par_info,1)

#define parGlobalZh(r,node,identifier,gran_info,size_info,par_info,rest) \
	PARZh(r,node,rest,identifier,gran_info,size_info,par_info,0)

#if 1

#define PARZh(r,node,rest,identifier,gran_info,size_info,par_info,local) \
{							\
  if (SHOULD_SPARK(node)) {				\
    SaveAllStgRegs();		   	                \
    { sparkq result;						\
      result = NewSpark((P_)node,identifier,gran_info,size_info,par_info,local);\
      add_to_spark_queue(result); 				\
      GranSimSpark(local,(P_)node);	                                \
      context_switch = 1;                        	\
    }                                                   \
    RestoreAllStgRegs();			        \
  } else if (do_qp_prof) {				\
    I_ tid = threadId++;				\
    SAFESTGCALL2(void,(I_, P_),QP_Event0,tid,node);	\
  }							\
  r = 1; 	\
}

#else

#define PARZh(r,node,rest,identifier,gran_info,size_info,par_info,local) \
{							\
  sparkq result;						\
  if (SHOULD_SPARK(node)) {				\
    result = NewSpark((P_)node,identifier,gran_info,size_info,par_info,local);\
    ADD_TO_SPARK_QUEUE(result);				\
    SAFESTGCALL2(void,(W_),GranSimSpark,local,(P_)node);	\
    	\
  } else if (do_qp_prof) {				\
    I_ tid = threadId++;				\
    SAFESTGCALL2(void,(I_, P_),QP_Event0,tid,node);	\
  }							\
  r = 1; 	\
}

#endif 

#define copyableZh(r,node)				\
  

#define noFollowZh(r,node)				\
  

#else  

extern I_ required_thread_count;

#ifdef PAR
#define COUNT_SPARK     TSO_GLOBALSPARKS(CurrentTSO)++
#else
#define COUNT_SPARK
#endif






#define forkZh(r,liveness,node)				\
{							\
  while (PendingSparksTl[REQUIRED_POOL] == PendingSparksLim[REQUIRED_POOL]) \
    DO_YIELD((liveness << 1) | 1);			\
  COUNT_SPARK;						\
  if (SHOULD_SPARK(node)) {				\
    *PendingSparksTl[REQUIRED_POOL]++ = (P_)(node);	\
  } else if (DO_QP_PROF) {				\
    I_ tid = threadId++;				\
    SAFESTGCALL2(void,(I_, P_),QP_Event0,tid,node);	\
  }							\
  required_thread_count++;				\
  context_switch = 1;					\
  r = 1; 			\
}

#define parZh(r,node)					\
{							\
  COUNT_SPARK;						\
  if (SHOULD_SPARK(node) &&				\
   PendingSparksTl[ADVISORY_POOL] < PendingSparksLim[ADVISORY_POOL]) {	\
    *PendingSparksTl[ADVISORY_POOL]++ = (P_)(node);	\
  } else {						\
    sparksIgnored++;					\
    if (DO_QP_PROF) {					\
      I_ tid = threadId++;				\
      SAFESTGCALL2(void,(I_, P_),QP_Event0,tid,node);	\
    }							\
  }							\
  r = 1; 			\
}

#endif   
# line 2070 "StgMacros.lh"

ED_RO_(vtbl_seq);

#define seqZh(r,liveness,node)		    \
  ({					    \
    __label__ cont;			    \
        \
     		    \
    SpB[BREL(0)] = (W_) RetReg;		    \
    SpB[BREL(1)] = (W_) &&cont;		    \
    RetReg = (StgRetAddr) vtbl_seq;	    \
    Node = node;			    \
    ENT_VIA_NODE();			    \
    InfoPtr = (D_)(INFO_PTR(Node));	    \
    JMP_(ENTRY_CODE(InfoPtr));		    \
    cont:				    \
    r = 1; 	    \
  })

#endif	
# line 2121 "StgMacros.lh"
#ifndef PAR

StgInt eqForeignObj PROTO((StgForeignObj p1, StgForeignObj p2));

#define makeForeignObjZh(r, liveness, mptr, finalise)    \
do {							 \
  P_ result;						 \
							 \
  HEAP_CHK((W_)liveness, _FHS + ForeignObj_SIZE,0);		 \
  CC_ALLOC(CCC,_FHS + ForeignObj_SIZE,ForeignObj_K);    \
								   \
  result = Hp + 1 - (_FHS + ForeignObj_SIZE);			   \
  SET_ForeignObj_HDR(result,ForeignObj_info,CCC,_FHS + ForeignObj_SIZE,0); \
  ForeignObj_CLOSURE_DATA(result)      = (P_)mptr;             	   \
  ForeignObj_CLOSURE_FINALISER(result) = (P_)finalise;         	   \
  ForeignObj_CLOSURE_LINK(result) = StorageMgrInfo.ForeignObjList; \
  StorageMgrInfo.ForeignObjList = result;			   \
							\
							\
  CHECK_ForeignObj_CLOSURE( result );			\
  VALIDATE_ForeignObjList( StorageMgrInfo.ForeignObjList ); \
							\
  (r) = (P_) result;					\
} while (0)

#else
#define makeForeignObjZh(r, liveness, mptr, finalise)	            \
do {								    \
    fflush(stdout);						    \
    fprintf(stderr, "makeForeignObj#: no foreign object support.\n");\
    EXIT(EXIT_FAILURE);						    \
} while(0)

#endif 
# line 2165 "StgMacros.lh"
#endif 
